a nagios script must be scheduled every 24 h to add a list of resources to all scopes

Apr 12, 2017 04:00 PM - Lucio Lelii

Status: Closed Start date: Apr 12, 2017

Priority: Immediate Due date:  

Assignee: _InfraScience Systems Engineer % Done: 100%

Category: Other Estimated time: 0.00 hour

Target version: UnSprintable   

Infrastructure: Production   

Description

Related issues:

Blocked by D4Science Infrastructure - VM Creation #8486: Provide a new SmartG... Closed May 11, 2017

History

#1 - Apr 12, 2017 04:01 PM - Lucio Lelii

- Subject changed from a nagios script must be sheduled every 24 h to add a list of resources to all scopes to a nagios script must be scheduled every

24 h to add a list of resources to all scopes

#2 - Apr 12, 2017 04:28 PM - Andrea Dell'Amico

- Assignee changed from Andrea Dell'Amico to _InfraScience Systems Engineer

Can you give us less information? With so many details we lose the joy of discovering new ways to mess up with our systems.

#3 - Apr 12, 2017 07:31 PM - Pasquale Pagano

- Priority changed from Low to Urgent

#5 - Apr 12, 2017 08:06 PM - Andrea Dell'Amico

Wy a nagios script anyway? Is it something that can be used as a check too?

#6 - Apr 12, 2017 08:17 PM - Pasquale Pagano

Nagios was my suggestion for the following reason:

it notifies when something happen

it keeps track of the history and we can understand how frequently we are loosing resources

it allows to easily schedule a check

Any other solution can be selected clearly. 

#7 - Apr 13, 2017 12:15 PM - Lucio Lelii

but this script only adds all the scope to the selected resource. The check for the scope loss in the resource should be done with a smartexecutor

plugin as reported in the ticket #7800 

#8 - Apr 13, 2017 01:56 PM - Andrea Dell'Amico

And is the plugin meant to run the script that restores the scopes too? Or we run it as a secondary effect of the nagios check?

From what I read on the other related tasks, a nagios check could run on the host where the smart executor plugin lives. The plugin could write its

results into a file (list of missing scopes, if any. 'none' if it's all OK). The nagios check will read that file, report the result and, if there are missing

scopes, run the script that fixes them. So the scopes would be added again in a matter of minutes and we will have a nagios report.

#9 - Apr 13, 2017 04:20 PM - Costantino Perciante

@lucio.lelii@isti.cnr.it told me that his script just needs the list of missing ids (no matter where the resources were missing, because the script adds

them everywhere again).

@andrea.dellamico@isti.cnr.it  Please, just let me know the path in which nagios will look for that file

May 02, 2025 1/4



#10 - Apr 13, 2017 06:52 PM - Andrea Dell'Amico

We need a place writeable by the gcube user. Anything under /home/gcube is fine with me, better a subdirectory.

/home/gcube/scopes_data/scopes_status maybe? where scopes_status is the filename?

#11 - Apr 19, 2017 10:34 AM - Costantino Perciante

Andrea Dell'Amico wrote:

We need a place writeable by the gcube user. Anything under /home/gcube is fine with me, better a subdirectory.

/home/gcube/scopes_data/scopes_status maybe? where scopes_status is the filename?

 Since we are dealing with identifiers of resources, I would say that /home/gcube/missing_resources/identifiers is ok too, isn't it? ("identifiers" is the file

name)

Moreover, is there a place in dev in which we can test both the smart-executor plugin and the script?

#12 - Apr 19, 2017 12:48 PM - Andrea Dell'Amico

Costantino Perciante wrote:

Andrea Dell'Amico wrote:

We need a place writeable by the gcube user. Anything under /home/gcube is fine with me, better a subdirectory.

/home/gcube/scopes_data/scopes_status maybe? where scopes_status is the filename?

 Since we are dealing with identifiers of resources, I would say that /home/gcube/missing_resources/identifiers is ok too, isn't it? ("identifiers" is

the file name)

 Yes, no probl.

Moreover, is there a place in dev in which we can test both the smart-executor plugin and the script?

 It's a question for @lucio.lelii@isti.cnr.it I guess.

#13 - Apr 19, 2017 03:07 PM - Lucio Lelii

- File AddResourcesToAllScopes.java added

I have just attached the script to add all scopes to the selected resource ids.

Run it with the command:

java AddResourcesToAllScopes id1 id2 ... idn

 with the smartgears classpath.

#14 - Apr 19, 2017 06:48 PM - Pasquale Pagano

- Priority changed from Urgent to Immediate

We had another issue in production and another ticket from the user. It is fundamental to implement this workaround now. 

#18 - Apr 19, 2017 07:51 PM - Andrea Dell'Amico

Lucio Lelii wrote:

I have just attached the script to add all scopes to the selected resource ids.

Run it with the command:

java AddResourcesToAllScopes id1 id2 ... idn

 with the smartgears classpath.

 So I need to run it on a smartgears node, the one that collects the missing IDs. I still don't know what node is that to be used.

The java source should live on subversion, btw.

#19 - Apr 21, 2017 11:43 AM - Costantino Perciante

The smart executor plugin will run every hour, starting from now, on the node resource-checker-d-d4s.d4science.org. It will write a file with the
missing resources' identifiers at /home/gcube/missing_resources/identifiers (it will contain "none" if nothing is wrong). Please perform the other

missing operations to let Lucio's code properly work

#20 - Apr 21, 2017 04:27 PM - Andrea Dell'Amico

@lucio.lelii@isti.cnr.it the java source has a fixed list of VO from production. I cannot use it to test in dev. Can you provide a binary, btw?

#21 - Apr 21, 2017 04:35 PM - Lucio Lelii

yes, the list of VOs is fixed for the production, I can change the script with 2 options:  

the script takes as argument the list of VOs

the script has a fixed list of production VOs and a list of development VOs and you can select the environment passing a special argument

Tell me which one you prefer.

#22 - Apr 21, 2017 04:45 PM - Costantino Perciante

What if we use the smart-executor plugin for this task too?

I mean, no other external file/scripts/whatever, just the plugin.

#23 - Apr 21, 2017 05:07 PM - Andrea Dell'Amico

Costantino Perciante wrote:

What if we use the smart-executor plugin for this task too?

I mean, no other external file/scripts/whatever, just the plugin.

 It sounds better to me. So the nagios check should report the status change only. Correct?

#24 - Apr 21, 2017 05:18 PM - Costantino Perciante

Andrea Dell'Amico wrote:

Costantino Perciante wrote:

What if we use the smart-executor plugin for this task too?

I mean, no other external file/scripts/whatever, just the plugin.

 It sounds better to me. So the nagios check should report the status change only. Correct?

 ok! 

@lucio.lelii@isti.cnr.it the plugin already evaluates the list of VOs (taking into account the infrastructure in which it is running, of course).

I guess I can easily import your code in the resource-checker plugin

#25 - Apr 24, 2017 10:45 AM - Costantino Perciante

The updated script is running on that node. It also takes care of re-adding any missing resource to a context.

#26 - May 11, 2017 07:47 PM - Andrea Dell'Amico

- Blocked by VM Creation #8486: Provide a new SmartGears node for resource-checker plugin added

#27 - May 11, 2017 07:48 PM - Andrea Dell'Amico

- File deleted (AddResourcesToAllScopes.java)

#28 - May 12, 2017 11:39 AM - Pasquale Pagano

This activity was urgent one month ago. Please try to complete it asap.

#29 - May 12, 2017 12:26 PM - Andrea Dell'Amico

Pasquale Pagano wrote:

This activity was urgent one month ago. Please try to complete it asap.

 As soon as the production service works.
#30 - Jun 02, 2017 03:31 PM - Andrea Dell'Amico

- Status changed from New to Closed

- % Done changed from 0 to 100

- Infrastructure deleted (Development)

Done. The check goes to CRITICAL if the /home/gcube/missing_resources/identifiers file contains anything different than the string none.
